/*
 *		 bLEDd 1.0
 *  Created on: 01-03-2013
 *       Autor: barney
 *       swiatelka.pl
 */
#include <avr/io.h>
#include <util/delay.h>
#include <avr/eeprom.h>
#include <avr/interrupt.h>
#include "setup.h"
#define AMC  			(1<<PB1)
#define PWM  			OCR0B
#define TRYB 			(cfg_ram.ktory_tryb>>1)
#define STP_SLT(SLT)	(((SLOT##SLT##_STRB)<<3)+(SLOT##SLT##_LVL)-1)
typedef uint8_t u08;
typedef struct
{
	u08 jasnosci    	[8];
	u08 strb_time1  	[3];
	u08 strb_factor1	[3];
	u08 strb_time2     	[3];
	u08 strb_factor2   	[3];
} TSET;
typedef struct
{
	u08 ktory_tryb;
	u08 ile_trybow;
	u08 klikniecia;
	u08 rower;
	u08 sloty          	[8];
	u08 menu;
	u08 menu_lvl		[3];
} TCFG;
TSET set_epr EEMEM =
{
		{LVL1, LVL2, LVL3, LVL4, LVL5, LVL6, LVL7, LVL8},
		{STRB1_TIME1,      STRB2_TIME1,      STRB3_TIME1},
		{STRB1_FACTOR1,    STRB2_FACTOR1,    STRB3_FACTOR1},
		{STRB1_TIME2,      STRB2_TIME2,      STRB3_TIME2},
		{STRB1_FACTOR2,    STRB2_FACTOR2,    STRB3_FACTOR2}
};
TCFG cfg_epr EEMEM =
{
		(AKTUALNY_SLOT - 1)<<1,
		SLOTY_WLACZONE - 1,
		0,
		TRYB_ROWEROWY,
		{STP_SLT(1), STP_SLT(2), STP_SLT(3), STP_SLT(4), STP_SLT(5), STP_SLT(6), STP_SLT(7), STP_SLT(8)},
		0,
		{0, 0, 0}
};
TCFG cfg_ram;
TSET set_ram;
u08 czas, licznik, jasnosc_obecna, numer_stroboskopu;
volatile u08 wdt_epr=0;

inline void odczytaj_epr (void)
{
	eeprom_read_block(&cfg_ram, &cfg_epr, sizeof(cfg_ram));
	eeprom_read_block(&set_ram, &set_epr, sizeof(set_epr));
	cfg_ram.ile_trybow&=0b00000111;							// Proste poprawianie struktury na wypedek blednego zapisu EEPROMU
}
inline void zapisz_epr (void) {eeprom_write_block(&cfg_ram, &cfg_epr, sizeof(cfg_ram));}
inline void wyzeruj_menu (void)
{
	cfg_ram.menu=0;											// Wylaczenie programowania
	cfg_ram.menu_lvl[1]=0;
	cfg_ram.klikniecia=0;									// Wyzerowanie licznika klikniec
}
inline void ignoruj_klik (void)
{
	cfg_ram.ktory_tryb&=0b11111110;
	cfg_ram.klikniecia=0;
}

int main (void)
{
	DDRB   |= AMC;                      					// kierunek pinu AMC wyjsciowy
    TCCR0A |= (1<<WGM01) | (1<<WGM00) | (1<<COM0B1);		// fast PWM, Clear OC0B on Compare Match
    TCCR0B |= (1<<CS00);         							// prescaler 1

	odczytaj_epr();                            				// Odczytanie zawartosci EEPROM
	if (!cfg_ram.rower)										// Jezeli driver nie jest zablokowany
	{
		if ((cfg_ram.menu==3) || (cfg_ram.menu_lvl[1]>3))	// Rozpiska z programowania
		{													// Programowanie slotow
			if (cfg_ram.menu_lvl[1]<4) cfg_ram.sloty[cfg_ram.menu_lvl[0]]=(cfg_ram.menu_lvl[1]<<3) | cfg_ram.menu_lvl[2];
			if (cfg_ram.menu_lvl[1]==4)						// Programowanie slotu rowerowego
			{
				cfg_ram.rower=1;
				cfg_ram.ktory_tryb=(cfg_ram.menu_lvl[0]<<1);
			}
			else
				cfg_ram.ktory_tryb=0;						// Ustawianie slotu pierwszego jako aktywny
			if (cfg_ram.menu_lvl[1]==5) cfg_ram.ile_trybow=cfg_ram.menu_lvl[0];
			wyzeruj_menu();									// Programowanie ilosci aktywnych slotow
		}
		else
		{													// Obsluga klikniec
			if (cfg_ram.ktory_tryb & 0b00000001) cfg_ram.ktory_tryb+=2; else cfg_ram.ktory_tryb++;
			if (TRYB>cfg_ram.ile_trybow) cfg_ram.ktory_tryb=1;
		}
		if (cfg_ram.klikniecia==MENU_IN)					// Programowanie
		{
			for (licznik=0; licznik<MENU_SIG_RPT; licznik++)
				{
					PWM=MENU_LVL1;  _delay_ms (MENU_TIME1);
					PWM=MENU_LVL2;	_delay_ms (MENU_TIME2);
				}
			cfg_ram.menu++;
			for (licznik=0; licznik<MENU_CHOOSE_RPT; licznik++)
				for (czas=0; czas<8; czas++)
				{
					cfg_ram.menu_lvl[cfg_ram.menu-1]=czas;
					zapisz_epr();
					PWM=set_ram.jasnosci[czas];  _delay_ms(MENU_CHOOSE_TIME);
				}
			wyzeruj_menu();									// Jezeli nic nie wybrano to wychodzimy
		}
	}
	else
		if (cfg_ram.klikniecia==ROWER_STOP)					// Wyjscie z trybu rowerowego
		{
			cfg_ram.rower=0;
			cfg_ram.klikniecia=0;
		}
	cfg_ram.klikniecia++;
	zapisz_epr();											// Zapis EEPROM

	ADMUX  |= (1<<REFS0)| (1<<MUX0)  | (1<<ADLAR);  		// 1.1V, PB2, 8bit
	ADCSRA |= (1<<ADEN) | (1<<ADPS2) | (1<<ADPS0)|(1<<ADSC);// Wlaczenie ADC, prescaler 32, wykonanie pomiaru
	WDTCR  |= (1<<WDTIE)| (1<<WDP1)  | (1<<WDP0);			// Watchdog - przerwanie, prescaler 8 -> przerwanie co ~128ms
	sei();													// Odblokowanie przerwan

	licznik=0;												// Ustalanie jasnosci i obecnosci stroboskopu
	jasnosc_obecna=set_ram.jasnosci[cfg_ram.sloty[TRYB] & 0b00000111];
	numer_stroboskopu=cfg_ram.sloty[TRYB]>>3;
	if (numer_stroboskopu)
	{
		numer_stroboskopu--;
		licznik=1;
	}
	while (1)												// Swiecenie
	{
		if (wdt_epr)
		{
			wdt_epr=0;
			ignoruj_klik();
			zapisz_epr();
			PWM=jasnosc_obecna/IGN_CLICK_FACTOR;  _delay_ms(IGN_CLICK_SIG);
		}
		if (licznik)
		{
			for (czas=0; (czas<set_ram.strb_time1[numer_stroboskopu]) && (!wdt_epr); czas++) {PWM=jasnosc_obecna/set_ram.strb_factor1[numer_stroboskopu];  _delay_ms (STRB_TIME1);}
			for (czas=0; (czas<set_ram.strb_time2[numer_stroboskopu]) && (!wdt_epr); czas++) {PWM=jasnosc_obecna/set_ram.strb_factor2[numer_stroboskopu];  _delay_ms (STRB_TIME2);}
		}
		else
			PWM=jasnosc_obecna;
	}
}
ISR (WDT_vect)
{
	static u08 batt=0, ign=0;								// Ignorowanie klikniecia
	if (ign<IGN_CLICK_TIME)	if (++ign==IGN_CLICK_TIME) wdt_epr=1;
	if ((++batt==BATT_PAUSE) & (!wdt_epr))					// Sprawdzanie napiecia baterii
	{
		batt=0;
		if (ADCH<BATT_LEVEL) {PWM=jasnosc_obecna/BATT_FACTOR;  _delay_ms(BATT_TIME);}
		ADCSRA |= (1<<ADSC);								// Podanie startu ADC
	}
}
